diff -Naur --exclude=CVS --exclude=configs linux/include/linux/elf.h linux-openmosix/include/linux/elf.h
--- linux/include/linux/elf.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/linux/elf.h	2004-02-05 10:51:27.000000000 +0100
@@ -607,5 +607,18 @@
 
 #endif
 
+#ifdef CONFIG_MOSIX
+#ifdef __KERNEL__
+struct elf_tables_extras
+{
+	int uid, euid, gid, egid;
+	long hwcap;
+	char platform[8];
+};
+
+extern unsigned long elf_remote_setup(char *, int, int, struct elfhdr *, unsigned long, unsigned long, unsigned long, int, int, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, struct elf_tables_extras *);
+extern int elf_maydump(struct vm_area_struct *);
+#endif /*__KERNEL__*/
+#endif /* CONFIG_MOSIX */
 
 #endif /* _LINUX_ELF_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/errno.h linux-openmosix/include/linux/errno.h
--- linux/include/linux/errno.h	2001-02-09 23:46:13.000000000 +0100
+++ linux-openmosix/include/linux/errno.h	2004-02-05 10:51:27.000000000 +0100
@@ -21,6 +21,10 @@
 #define EBADTYPE	527	/* Type not supported by server */
 #define EJUKEBOX	528	/* Request initiated, but will not complete before timeout */
 
+#ifdef CONFIG_MOSIX
+#define	EDOITATHOME	550
+#endif /* CONFIG_MOSIX */
+
 #endif
 
 #endif
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/file.h linux-openmosix/include/linux/file.h
--- linux/include/linux/file.h	2002-08-03 02:39:45.000000000 +0200
+++ linux-openmosix/include/linux/file.h	2004-02-05 10:51:27.000000000 +0100
@@ -5,6 +5,10 @@
 #ifndef __LINUX_FILE_H
 #define __LINUX_FILE_H
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 extern void FASTCALL(fput(struct file *));
 extern struct file * FASTCALL(fget(unsigned int fd));
  
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/fs.h linux-openmosix/include/linux/fs.h
--- linux/include/linux/fs.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/linux/fs.h	2004-02-05 10:51:27.000000000 +0100
@@ -34,8 +34,8 @@
  * nr_file rlimit, so it's safe to set up a ridiculously high absolute
  * upper limit on files-per-process.
  *
- * Some programs (notably those using select()) may have to be 
- * recompiled to take full advantage of the new limits..  
+ * Some programs (notably those using select()) may have to be
+ * recompiled to take full advantage of the new limits..
  */
 
 /* Fixed constants first: */
@@ -84,7 +84,7 @@
 #define SEL_EX		4
 
 /* public flags for file_system_type */
-#define FS_REQUIRES_DEV 1 
+#define FS_REQUIRES_DEV 1
 #define FS_NO_DCACHE	2 /* Only dcache the necessary things. */
 #define FS_NO_PRELIM	4 /* prevent preloading of dentries, even if
 			   * FS_NO_DCACHE is not set.
@@ -151,7 +151,12 @@
  */
 #define __IS_FLG(inode,flg) ((inode)->i_sb->s_flags & (flg))
 
+#if defined(CONFIG_MOSIX_FS) && defined(__KERNEL__)
+#define IS_RDONLY(inode) (((inode)->i_sb->s_flags & MS_RDONLY) || \
+				(current->mosix.dirty_bits & MFSARG_RONLY))
+#else
 #define IS_RDONLY(inode) ((inode)->i_sb->s_flags & MS_RDONLY)
+#endif /* CONFIG_MOSIX_FS && __KERNEL__ */
 #define IS_SYNC(inode)		(__IS_FLG(inode, MS_SYNCHRONOUS) || ((inode)->i_flags & S_SYNC))
 #define IS_MANDLOCK(inode)	__IS_FLG(inode, MS_MANDLOCK)
 
@@ -235,10 +240,10 @@
  * Try to keep the most commonly used fields in single cache lines (16
  * bytes) to improve performance.  This ordering should be
  * particularly beneficial on 32-bit processors.
- * 
+ *
  * We use the first 16 bytes for the data which is used in searches
  * over the block hash lists (ie. getblk() and friends).
- * 
+ *
  * The second 16 bytes we use for lru buffer scans, as used by
  * sync_buffers() and refill_freelist().  -- sct
  */
@@ -322,6 +327,12 @@
 #include <linux/usbdev_fs_i.h>
 #include <linux/jffs2_fs_i.h>
 #include <linux/cramfs_fs_sb.h>
+#ifdef CONFIG_MOSIX
+#include <linux/remote_fs_i.h>
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs_fs_i.h>
+#endif /* CONFIG_MOSIX_FS */
+#endif /* CONFIG_MOSIX */
 
 /*
  * Attribute flags.  These should be or-ed together to figure out what
@@ -439,7 +450,7 @@
 	struct list_head	i_hash;
 	struct list_head	i_list;
 	struct list_head	i_dentry;
-	
+
 	struct list_head	i_dirty_buffers;
 	struct list_head	i_dirty_data_buffers;
 
@@ -518,7 +529,16 @@
 		struct usbdev_inode_info        usbdev_i;
 		struct jffs2_inode_info		jffs2_i;
 		void				*generic_ip;
+#ifdef CONFIG_MOSIX
+		struct remote_inode_info	remote_i;
+#ifdef CONFIG_MOSIX_FS
+		struct mfs_inode_info		mfs_i;
+#endif /* CONFIG_MOSIX_FS */
+#endif /* CONFIG_MOSIX */
 	} u;
+#ifdef CONFIG_MOSIX
+	uint64_t		i_unique;
+#endif /* CONFIG_MOSIX */
 };
 
 static inline void inode_add_bytes(struct inode *inode, loff_t bytes)
@@ -698,6 +718,46 @@
 	struct qstr last;
 	unsigned int flags;
 	int last_type;
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+	char *name_left;
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_FS
+	unsigned short express_function;
+	union complete_args
+	{
+		struct
+		{
+			int i1;
+			int i2;
+		} ints;
+		struct
+		{
+			time_t a;
+			time_t m;
+		} times;
+		struct
+		{
+			uid_t uid;
+			gid_t gid;
+		} ids;
+		struct
+		{
+			int mode;
+			dev_t dev;
+		} mknod;
+		mode_t mode;
+		loff_t len;
+		struct
+		{
+			char *buf;
+			int bufsiz;
+		} buffer;
+		struct nameidata *oldnd;
+		struct statfs *statfs;
+	} complete_args;
+	void *complete_parg;
+	unsigned int complete_flags;
+#endif /* CONFIG_MOSIX_FS */
 };
 
 /*
@@ -894,6 +954,12 @@
 	int (*revalidate) (struct dentry *);
 	int (*setattr) (struct dentry *, struct iattr *);
 	int (*getattr) (struct dentry *, struct iattr *);
+#ifdef CONFIG_MOSIX_FS
+        int (*express_lookup) (struct nameidata *, char **);
+#endif /* CONFIG_MOSIX_FS */
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+        void (*check_path) (struct dentry *);
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
 	int (*setxattr) (struct dentry *, const char *, void *, size_t, int);
 	ssize_t (*getxattr) (struct dentry *, const char *, void *, size_t);
 	ssize_t (*listxattr) (struct dentry *, char *, size_t);
@@ -911,7 +977,7 @@
 	void (*destroy_inode)(struct inode *);
 
 	void (*read_inode) (struct inode *);
-  
+
   	/* reiserfs kludge.  reiserfs needs 64 bits of information to
     	** find an inode.  We are using the read_inode2 call to get
    	** that information.  We don't like this, and are waiting on some
@@ -958,6 +1024,11 @@
 	struct dentry * (*fh_to_dentry)(struct super_block *sb, __u32 *fh, int len, int fhtype, int parent);
 	int (*dentry_to_fh)(struct dentry *, __u32 *fh, int *lenp, int need_parent);
 	int (*show_options)(struct seq_file *, struct vfsmount *);
+#ifdef CONFIG_MOSIX_DFSA
+	int (*identify) (struct dentry *, void *);
+	struct dentry * (*reconstruct) (struct vfsmount *, void *, int);
+	void (*dfsa_changed) (struct vfsmount *, int);
+#endif /* CONFIG_MOSIX_DFSA */
 };
 
 /* Inode state bits.. */
@@ -1030,7 +1101,7 @@
 
 /* Return value for VFS lock functions - tells locks.c to lock conventionally
  * REALLY kosha for root NFS and nfs_lock
- */ 
+ */
 #define LOCK_USE_CLNT 1
 
 #define FLOCK_VERIFY_READ  1
@@ -1311,7 +1382,7 @@
 
 extern int kernel_read(struct file *, unsigned long, char *, unsigned long);
 extern struct file * open_exec(const char *);
- 
+
 /* fs/dcache.c -- generic fs support functions */
 extern int is_subdir(struct dentry *, struct dentry *);
 extern ino_t find_inode_number(struct dentry *, struct qstr *);
@@ -1352,6 +1423,47 @@
 #define LOOKUP_POSITIVE		(8)
 #define LOOKUP_PARENT		(16)
 #define LOOKUP_NOALT		(32)
+
+#ifdef CONFIG_MOSIX_DFSA
+#define	LOOKUP_STAYFS		(64)
+#define	LOOKUP_DOITATHOME	(128)
+#define	LOOKUP_REPLACENAME	(256)
+#else
+#define	LOOKUP_STAYFS		(0)
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+#define	LOOKUP_MFS		(512)
+#define	LOOKUP_COMPLETE		(1024)
+#define	LOOKUP_MFS_MFS		(2048)
+
+/* complete_flags: */
+#define	COMPLETE_DONE		1
+#define	COMPLETE_MAGICAL	2
+
+/* express functions: */
+enum express_functions
+{
+	EF_OPEN = 1,
+	EF_ACCESS,
+	EF_LINK,
+	EF_UNLINK,
+	EF_SYMLINK,
+	EF_MKDIR,
+	EF_RMDIR,
+	EF_RENAME,
+	EF_READLINK,
+	EF_TRUNCATE,
+	EF_UTIME,
+	EF_UTIMES,
+	EF_CHMOD,
+	EF_CHOWN,
+	EF_STAT,
+	EF_MKNOD,
+	EF_STATFS
+};
+
+#endif /* CONFIG_MOSIX_FS */
+
 /*
  * Type of the last component on LOOKUP_PARENT
  */
@@ -1674,6 +1786,16 @@
 	dput(d2);
 }
 
+#ifdef CONFIG_MOSIX
+extern spinlock_t unique_gen_lock;
+extern uint64_t unique_generator;
+#define	OPENMOSIX_VMODIFIED(_ip) do { \
+				spin_lock(&unique_gen_lock); \
+				_ip->i_unique = ++unique_generator; \
+				spin_unlock(&unique_gen_lock); \
+			} while(0)
+#endif /* CONFIG_MOSIX */
+
 #endif /* __KERNEL__ */
 
 #endif /* _LINUX_FS_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/fs_struct.h linux-openmosix/include/linux/fs_struct.h
--- linux/include/linux/fs_struct.h	2001-07-14 00:10:44.000000000 +0200
+++ linux-openmosix/include/linux/fs_struct.h	2004-02-05 10:51:27.000000000 +0100
@@ -2,12 +2,24 @@
 #define _LINUX_FS_STRUCT_H
 #ifdef __KERNEL__
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 struct fs_struct {
 	atomic_t count;
 	rwlock_t lock;
 	int umask;
 	struct dentry * root, * pwd, * altroot;
 	struct vfsmount * rootmnt, * pwdmnt, * altrootmnt;
+#ifdef CONFIG_MOSIX_DFSA
+	atomic_t users;
+	short count_dropped_to_one;
+	short pwd_changed;
+#define	INIT_FS_DFSA	, ATOMIC_INIT(1), 0, 0
+#else
+#define	INIT_FS_DFSA
+#endif /* CONFIG_MOSIX_DFSA */
 };
 
 #define INIT_FS { \
@@ -15,6 +27,7 @@
 	RW_LOCK_UNLOCKED, \
 	0022, \
 	NULL, NULL, NULL, NULL, NULL, NULL \
+	INIT_FS_DFSA \
 }
 
 extern void exit_fs(struct task_struct *);
@@ -41,6 +54,9 @@
 		dput(old_root);
 		mntput(old_rootmnt);
 	}
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_is_not_up_to_date();
+#endif /* CONFIG_MOSIX_DFSA */
 }
 
 /*
@@ -60,6 +76,10 @@
 	fs->pwdmnt = mntget(mnt);
 	fs->pwd = dget(dentry);
 	write_unlock(&fs->lock);
+#ifdef CONFIG_MOSIX_DFSA
+	if(fs->pwdmnt != old_pwdmnt || fs->pwd != old_pwd)
+		dfsa_pwd_changed();
+#endif /* CONFIG_MOSIX_DFSA */
 	if (old_pwd) {
 		dput(old_pwd);
 		mntput(old_pwdmnt);
@@ -68,6 +88,9 @@
 
 struct fs_struct *copy_fs_struct(struct fs_struct *old);
 void put_fs_struct(struct fs_struct *fs);
+#ifdef CONFIG_MOSIX_DFSA
+void put_used_fs_struct(struct fs_struct *fs);
+#endif /* CONFIG_MOSIX_DFSA */
 
 #endif
 #endif
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/hpcctl.h linux-openmosix/include/linux/hpcctl.h
--- linux/include/linux/hpcctl.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/hpcctl.h	2002-08-26 06:37:27.000000000 +0200
@@ -0,0 +1,38 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Moshe Bar, Oren Laadan.
+ */
+#ifndef _LINUX_MOSCTL_H
+#define _LINUX_MOSCTL_H
+
+#ifdef __KERNEL__
+#include <linux/socket.h>
+#else
+#include <sys/socket.h>
+#endif /*__KERNEL__*/
+
+#include <hpc/hpcctl.h>
+
+/* configuration */
+
+#define MOSIX_MAX	65535 /* max number of hosts in openMosix */
+#define MAX_MOSNET_ENTS	256   /* max number of netx in openMosix */
+
+struct mosixnet
+{
+	int base;
+	struct sockaddr saddr;
+	int cnt;
+};
+
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/hpc.h linux-openmosix/include/linux/hpc.h
--- linux/include/linux/hpc.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/hpc.h	2004-02-05 02:48:29.000000000 +0100
@@ -0,0 +1,179 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar moshe@moelabs.com
+ *
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+#ifndef _LINUX_MOSIX_H
+#define _LINUX_MOSIX_H
+
+#ifdef CONFIG_MOSIX
+
+#ifdef __KERNEL__
+
+#include <linux/sched.h>
+#include <linux/user.h>
+#include <linux/elf.h>
+#include <hpc/defs.h>
+#include <hpc/request.h>
+
+/* operations on DEPUTY's data-base of REMOTE files: */
+
+extern int mosix_register_a_file(struct file *, int);
+extern void mosix_undo_last_file_registration(struct file *, int);
+extern int mosix_rebuild_file_list(void);
+extern void mosix_update_remote_files(void);
+
+struct vmalist
+{
+	unsigned int vmstart;
+	unsigned int vmend;
+	unsigned short vmflags;
+	short	maydump;
+};
+
+struct vmamaps
+{
+	unsigned long vmstart, vmend, vmflags, vmpgoff;
+	struct file *fp;
+};
+
+extern void init_mosix(void);
+extern void wake_up_mosix(struct task_struct *);
+extern int mosix_wakeable(struct task_struct *);
+extern int mosix_go_home(int);
+extern int mosix_go_home_for_reason(int, int);
+extern int mosix_send_back_home(struct task_struct *);
+extern int mosix_need_while_asleep(void);
+extern void mosix_run_while_asleep(void);
+extern void mosix_pre_usermode_functions(void);
+extern int stay_me_and_my_clones(uint32_t);
+extern void unstay_mm(struct mm_struct *);
+extern void mosix_inform_remote_of_nice(void);
+extern void mosix_snap_load(int);
+extern void mosix_clear_statistics(void);
+extern int mosix_fork_init_fields(struct task_struct *);
+extern void mosix_fork_free_fields(struct task_struct *);
+extern void mosix_exit(void);
+extern void mosix_very_exit(void);
+extern void mosix_obtain_registers(unsigned long);
+extern void mosix_bring_monkey_users_back(struct inode *);
+extern void mosix_no_longer_monkey(struct inode *);
+extern void mosix_check_for_freedom_to_move(void);
+extern int mosix_pre_clone(void);
+extern void mosix_post_clone(void);
+extern void mosix_remote_syscall_trace(void);
+extern u64 mosix_remote_tsc(void);
+extern int mosix_forkmigrate(void);
+extern int mosix_deputy_fork(struct task_struct *, int, unsigned long);
+extern void mosix_exit_mm(struct task_struct *);
+extern void mosix_exec_mmap(struct mm_struct *);
+extern void mosix_deputy_rusage(int);
+extern int mosix_deputy_personality(unsigned long);
+extern void mosix_deputy_count_args(char **, char**, int *, int *);
+extern int mosix_deputy_bring_strings(struct linux_binprm *, char *, char **, char **);
+extern int mosix_deputy_setup_args(int, unsigned long *);
+extern int mosix_deputy_exec_mmap(char *);
+extern int mosix_deputy_dump_thread(struct user *);
+extern void mosix_deputy_init_aout_mm(struct exec *);
+extern unsigned long mosix_deputy_elf_setup(char *, int, int, struct elfhdr *, unsigned long, unsigned long, unsigned long, int, int, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long, struct elf_tables_extras *);
+extern void mosix_deputy_fix_elf_aout_interp(unsigned, unsigned, unsigned);
+extern int mosix_deputy_list_vmas(struct vmalist **, unsigned long *, unsigned long *);
+extern long mosix_deputy_brk(unsigned long, unsigned long);
+
+extern void mosix_notify_urgent(struct socket *);
+extern void mosix_notify_receive(struct socket *);
+
+extern void mosix_proc_init(void);
+extern int mosix_proc_get_remote_array(char *, int, int);
+extern int mosix_proc_get_node_array(char *, int, int);
+
+extern void mosix_decay_exec(void);
+extern void mosix_add_to_whereto(struct task_struct *, int);
+extern void mosix_do_add_to_whereto(struct task_struct *, int);
+
+struct sockaddr;
+extern int reserved_mosix_address(struct sockaddr *);
+extern void comm_report_violation(char *, struct sockaddr *);
+
+void init_guest_user_struct(void);
+extern int get_free_guest_slots(void);
+extern int count_guests(void);
+#ifdef CONFIG_MOSIX_FS
+int mfs_client_statfs(int, mfs_handle_t, struct statfs *);
+#endif /* CONFIG_MOSIX_FS */
+/* argument of mosix_deputy_setup_args: */
+#define	SETUP_ARGS_PLAIN	0	
+#define	SETUP_ARGS_AS_AOUT	1
+#define	SETUP_ARGS_AS_ELF	2
+#define	SETUP_ARGS_NOTYET	3
+
+extern int mosix_deputy_restore_sigcontext(struct sigcontext *, int *);
+extern void mosix_deputy_setup_frame(unsigned long, struct k_sigaction *, siginfo_t, sigset_t *);
+extern unsigned long mosix_deputy_mmap(struct file *, unsigned long, int, unsigned long, unsigned long, unsigned long, off_t, nopage_t);
+extern int deputy_munmap(unsigned long, size_t);
+extern int deputy_mprotect(unsigned long, size_t, unsigned long);
+extern void mosix_deputy_rlimit(int, struct rlimit);
+extern int mosix_deputy_dump_fpu(struct user_i387_struct *);
+extern int mosix_sync_caps(kernel_cap_t);
+
+#define	ALL_REGISTERS	0x7fff	/* as many as in struct pt_regs */
+#define	BIT_OF_REGISTER(_which) \
+	(1 << (((int)&(((struct pt_regs *)0)->_which)) / sizeof(int)))
+
+/*
+ * meaning of signals on REMOTE
+ */
+
+#define	FATAL_SIGSEGV		SIGINT
+#define	REMOTE_FILE_RELEASED	SIGQUIT
+
+/* other signals that can occur on REMOTE:
+ * SIGKILL, SIGSEGV, SIGPROF, SIGVTALRM, SIGFPE, SIGBUS, SIGIOT, SIGILL,
+ * SIGXCPU, SIGXFSZ, SIGPROF, SIGTRQAP, SIGPWR (a tricky one).
+ * SIGTERM requires the process to migrate back.
+ */
+
+#define	MOSIX_PRIORITY		(100)
+#define	MOSIX_ASLEEP_PRIORITY	(MOSIX_PRIORITY * 3 / 10)
+#define	MOSIX_DEPUTY_PRIORITY	(MOSIX_PRIORITY * 1 / 10)
+#define	MOSIX_RESPOND_PRIORITY	(MOSIX_PRIORITY * 6 / 10)
+
+#define	PROC_MOSIX_USE_START	1024	/* coordinate with proc/fs/base.c */
+
+#if defined(CONFIG_MOSIX_DIAG) && defined(CONFIG_SMP)
+#define KERNEL_LOCKED	do{if(current->lock_depth == -1)panic("not locked %d of " __FILE__, __LINE__);}while(0)
+#define MOSIX_LOCKED	do{if(current->mosix.lock_depth == -1)panic("not locked %d of " __FILE__, __LINE__);}while(0)
+#else
+#define	KERNEL_LOCKED	do {} while(0)
+#define	MOSIX_LOCKED	do {} while(0)
+#endif /* CONFIG_MOSIX_DIAG */
+
+#define	mos_to_contact(m) ((struct socket *)((m)->contact))
+#define	mos_to_waitp(m)	((wait_queue_head_t *)(&(m)->wait_dist))
+#define mos_to_regs(m)	((struct pt_regs *)((m)->altregs))
+
+struct proc_dir_entry;
+extern struct proc_dir_entry *proc_mosix;
+typedef ssize_t (proc_mosix_pid_writer)(struct file *, struct task_struct *, const char *, size_t);
+extern proc_mosix_pid_writer proc_mosix_pid_set_migrate;
+extern proc_mosix_pid_writer proc_mosix_pid_set_goto;
+extern proc_mosix_pid_writer proc_mosix_pid_set_lock;
+extern proc_mosix_pid_writer proc_mosix_pid_set_sigmig;
+extern proc_mosix_pid_writer proc_mosix_pid_set_disclosure;
+extern proc_mosix_pid_writer proc_mosix_pid_set_migfilter;
+extern proc_mosix_pid_writer proc_mosix_pid_set_migpolicy;
+extern proc_mosix_pid_writer proc_mosix_pid_set_mignodes;
+extern proc_mosix_pid_writer proc_mosix_pid_set_miggroup;
+#ifdef CONFIG_MOSIX_FS
+extern proc_mosix_pid_writer proc_mosix_pid_set_selected;
+#endif /* CONFIG_MOSIX_FS */
+
+#endif /*__KERNEL__*/
+
+#endif /* CONFIG_MOSIX */
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/iobuf.h linux-openmosix/include/linux/iobuf.h
--- linux/include/linux/iobuf.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/linux/iobuf.h	2004-02-05 10:51:27.000000000 +0100
@@ -48,6 +48,9 @@
 	int		errno;		/* Status of completed IO */
 	void		(*end_io) (struct kiobuf *); /* Completion callback */
 	wait_queue_head_t wait_queue;
+#ifdef CONFIG_MOSIX
+	struct mm_struct *mm;
+#endif /* CONFIG_MOSIX */
 };
 
 
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/kernel.h linux-openmosix/include/linux/kernel.h
--- linux/include/linux/kernel.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/linux/kernel.h	2004-02-05 10:51:27.000000000 +0100
@@ -191,7 +191,8 @@
 	unsigned long totalhigh;	/* Total high memory size */
 	unsigned long freehigh;		/* Available high memory size */
 	unsigned int mem_unit;		/* Memory unit size in bytes */
-	char _f[20-2*sizeof(long)-sizeof(int)];	/* Padding: libc5 uses this.. */
+	char _f[20 - 2 * sizeof(long) - sizeof(int)];
+		/* Padding: libc5 uses this.. */
 };
 
 #define BUG_ON(condition) do { if (unlikely((condition)!=0)) BUG(); } while(0)
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/linkage.h linux-openmosix/include/linux/linkage.h
--- linux/include/linux/linkage.h	2000-12-11 21:49:54.000000000 +0100
+++ linux-openmosix/include/linux/linkage.h	2004-02-05 10:51:27.000000000 +0100
@@ -10,7 +10,13 @@
 #endif
 
 #if defined __i386__
+#if defined(CONFIG_MOSIX)
+/* there is a bug in egcs-2.91.66 using "regparm(0)" */
+/* it often crashes the compiler on some MOSIX files */
+#define asmlinkage CPP_ASMLINKAGE
+#else
 #define asmlinkage CPP_ASMLINKAGE __attribute__((regparm(0)))
+#endif /* CONFIG_MOSIX */
 #elif defined __ia64__
 #define asmlinkage CPP_ASMLINKAGE __attribute__((syscall_linkage))
 #else
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/mfs_fs_i.h linux-openmosix/include/linux/mfs_fs_i.h
--- linux/include/linux/mfs_fs_i.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/mfs_fs_i.h	2002-02-14 11:35:25.000000000 +0100
@@ -0,0 +1,27 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh.
+ */
+#ifndef _LINUX_MFS_FS_I_H
+#define _LINUX_MFS_FS_I_H
+#ifdef CONFIG_MOSIX
+
+typedef unsigned long long mfs_handle_t;
+
+struct mfs_inode_info
+{
+	int pe;
+	mfs_handle_t handle;
+};
+
+#endif /* CONFIG_MOSIX */
+#endif
